/*
 * IFS.h
 *
 *	Iterated Fractal System
 *
 *  Created on: Jul 30, 2012
 *      Author: scottyoung
 */

#ifndef IFS_H_
#define IFS_H_

#include "image.h"
#include "vectors.h"
#include "matrix.h"

class IFS {
public:
	//CONSTRUCTORS & DESTRUCTOR
	IFS(const char * filename);
	virtual ~IFS();

	void render(Image img, int pts, int iters);

private:
	int randTransform();

	//REPRESENTATION
	int n;
	Matrix *transforms;
	float *p;


};

#endif /* IFS_H_ */
