/*
 * main.cpp
 *
 *  Created on: Jul 30, 2012
 *      Author: scottyoung
 */

#include "ifs.h"
#include "image.h"
#include "matrix.h"
#include "vectors.h"
#include <iostream>

int main(int argc, char *argv[]){

	char *input_file = NULL;
	int width = 100;
	int height = 100;
	char *output_file = NULL;
	long points = 1000;
	int iters = 10;

	for (int i = 1; i < argc; i++) {
	  if (!strcmp(argv[i],"-input")) {
	    i++; assert (i < argc);
	    input_file = argv[i];
	  } else if (!strcmp(argv[i],"-size")) {
	    i++; assert (i < argc);
	    width = atoi(argv[i]);
	    i++; assert (i < argc);
	    height = atoi(argv[i]);
	  } else if (!strcmp(argv[i],"-output")) {
	    i++; assert (i < argc);
	    output_file = argv[i];
	  } else if (!strcmp(argv[i],"-points")) {
	    i++; assert (i < argc);
	    points = atol(argv[i]);
	  } else if (!strcmp(argv[i],"-iters")) {
	    i++; assert (i < argc);
	    iters = atoi(argv[i]);
	  } else {
	    printf ("whoops error with command line argument %d: '%s'\n",i,argv[i]);
	    assert(0);
	  }
	}

	Image img(width, height);
	IFS fractal(input_file);
	fractal.render(img, points, iters);
	img.SaveTGA(output_file);
	return 0;
}


