/*
 * Plane.cpp
 *
 *  Created on: Aug 14, 2012
 *      Author: scottyoung
 */

#include "Plane.h"

Plane::Plane(Vec3f n, float o, Vec3f color) {
	normal = n;
	normal.Normalize();
	offset = o;
	material = new Material(color);
}

Plane::~Plane() {

}

bool Plane::intersect(const Ray &r, Hit &h, float tMin)
{
	bool isHit = false;
	Vec3f N = normal;
	Vec3f P = r.getOrigin();
	Vec3f D = r.getDirection();
	float a = offset;

	//Does (N * D) != 0? (we have a hit)
	if(fabs(N.Dot3(D)) > .0001)
	{
		float tValue = (a - N.Dot3(P))/(N.Dot3(D));
		if(tValue > tMin && tValue < h.getT())
		{
			h.set(tValue, material, N, r);
			isHit = true;
		}
	}

	return(isHit);
}

void Plane::print(){
	cout << "Plane: offset =" << offset <<" normal = "
			<< normal.x() <<","<< normal.y()<<","<<normal.z()
			<< " color: (" << material->color.r() << "," << material->color.g() << "," << material->color.b() << ")" << endl;

}

