/*
 * OrthographicCamera.cpp
 *
 *  Created on: Aug 10, 2012
 *      Author: scottyoung
 */

#include "OrthographicCamera.h"

OrthographicCamera::OrthographicCamera(Vec3f c, Vec3f d, Vec3f u, float s) {
	center = c;
	direction = d;
	up = u;
	size = s;

	direction.Normalize();
	up.Normalize();
}

OrthographicCamera::~OrthographicCamera() {

}

Ray OrthographicCamera::generateRay(Vec2f point){

	Vec3f horizontal, origin;
	Vec3f::Cross3(horizontal, direction, up);
	origin = horizontal * (point.x()-.5)*size  +  up * (point.y()-.5)*size;
	origin += center;

	Ray r(direction, origin);

	return(r);
}

void OrthographicCamera::print(){
	cout << "Orthographic Camera: " << endl;
	cout << "\tCentered at: " << center.x() << ", " << center.y() << ", " << center.z() << endl;
	cout << "\tDirection : " << direction.x() << ", " << direction.y() << ", " << direction.z() << endl;
	cout << "\tUp: " << up.x() << ", " << up.y() << ", " << up.z() << endl;
	cout << "\tSize: " << size << endl;
}
