/*
 * RayTracer.h
 *
 *  Created on: Sep 4, 2012
 *      Author: scottyoung
 */

#ifndef RAYTRACER_H_
#define RAYTRACER_H_

#include "scene_parser.h"
#include "ray.h"
#include "hit.h"
#include "vectors.h"

//Epsilon is used for shadow casting to avoid immediate self-intersection on surfaces
#define EPSILON .0001

class RayTracer {
public:
	RayTracer(SceneParser *s, int b, float w)
	{
		theScene = s;
		maxBounces = b;
		minWeight = w;
	}
	virtual ~RayTracer();
	Vec3f traceRay(const Ray &r, float tMin, int bounces, float weight, float indexOfRefraction, Hit &h, int DEBUG_CODE=0) const;
	static Vec3f transmission(const Vec3f &I, const Vec3f &N, float index);

	SceneParser *theScene;
	int maxBounces;
	float minWeight;
};

#endif /* RAYTRACER_H_ */
