/*
 * MarchingInfo.h
 *
 *  Created on: Sep 11, 2012
 *      Author: scottyoung
 */

#ifndef MARCHINGINFO_H_
#define MARCHINGINFO_H_

#include "ray.h"
#include "BoundingBox.h"
#include "raytracing_stats.h"

class MarchingInfo {
public:
	MarchingInfo(Vec3f min, Vec3f max, int nx, int ny, int nz, const Ray &r, float tMinInitial);
	virtual ~MarchingInfo();
	void nextCell();
	int getX(){ return currX; }
	int getY(){ return currY; }
	int getZ(){ return currZ; }
	Vec3f getNormal() { return normal; }
	float getT(){ return t; }
	Vec3f getN(){ return normal; }


private:

	Vec3f calculateTNext(Vec3f grid, Vec3f min, Vec3f point, Vec3f dir);

	float tMin, t;
	int currX, currY, currZ;
	int signX, signY, signZ;
	Vec3f dt;
	Vec3f tNext;
	Vec3f normal;
};

#endif /* MARCHINGINFO_H_ */
