/*
 * PerspectiveCamera.cpp
 *
 *  Created on: Aug 14, 2012
 *      Author: scottyoung
 */

#include "PerspectiveCamera.h"
#include <math.h>
#define PI 3.141592

PerspectiveCamera::PerspectiveCamera(Vec3f c, Vec3f d, Vec3f u, float a) {
	center = c;
	direction = d;
	up = u;
	angle = a;

	direction.Normalize();
	up.Normalize();

}

PerspectiveCamera::~PerspectiveCamera() {
	// TODO Auto-generated destructor stub
}

Ray PerspectiveCamera::generateRay(Vec2f point){

	float yaw = (point.x()-.5) * angle;
	float pitch = (point.y()-.5) * angle;

	Vec3f horizontal;
	Vec3f::Cross3(horizontal, direction, up);

	double Alpha = sin(pitch);
	double Beta = sin(yaw);
	double Gamma = cos(angle/2.0);

	Vec3f dir = (direction*Gamma) + (horizontal*Beta) + (up*Alpha);

	dir.Normalize();

	//See if the length of the vector *should* be 1
	//cout << "len: " << sqrt(Alpha*Alpha + Beta*Beta + Gamma*Gamma) << endl;
	/*if(fabs(point.y()-1.0) < .001 && fabs(point.x()-1.0) < .001)
		cout << "Bottom-right vector is: " << dir.x() << "," << dir.y() << "," << dir.z() << endl;
	else if(fabs(point.y()-0.0) < .001 && fabs(point.x()-0.0) < .001)
		cout << "Top-left vector is: " << dir.x() << "," << dir.y() << "," << dir.z() << endl;
	else if(fabs(point.y()-1.0) < .001 && fabs(point.x()-0.0) < .001)
		cout << "Bottom-left vector is: " << dir.x() << "," << dir.y() << "," << dir.z() << endl;
	else if(fabs(point.y()-0.0) < .001 && fabs(point.x()-1.0) < .001)
		cout << "Top-right vector is: " << dir.x() << "," << dir.y() << "," << dir.z() << endl;
	*/

	Ray r(dir, center);
	return(r);
}

void PerspectiveCamera::print(){
	cout << "Perspective Camera: " << endl;
	cout << "\tCentered at: " << center.x() << ", " << center.y() << ", " << center.z() << endl;
	cout << "\tDirection : " << direction.x() << ", " << direction.y() << ", " << direction.z() << endl;
	cout << "\tUp: " << up.x() << ", " << up.y() << ", " << up.z() << endl;
	cout << "\tAngle: " << angle << endl;
}

