/*
 * Checkerboard.cpp
 *
 *  Created on: Sep 26, 2012
 *      Author: scottyoung
 */

#include "Checkerboard.h"

Checkerboard::Checkerboard(Material *m1, Material *m2, float cell_size)
	:Material(){
	odd = m1;
	even = m2;
	cellSize = cell_size;
}

Checkerboard::~Checkerboard() {
	// TODO Auto-generated destructor stub
}

//Prerendering uses only the odd material
void Checkerboard::glSetMaterial() const{
	even->glSetMaterial();
}

Vec3f Checkerboard::shade(const Ray &r, Hit *h, const Vec3f &dirToLight, const Vec3f &lightColor){
	int x, y, z;
	x = floor(h->getIntersectionPoint().x()/cellSize);
	y = floor(h->getIntersectionPoint().y()/cellSize);
	z = floor(h->getIntersectionPoint().z()/cellSize);
	if((x+y+z)%2 == 0)
		return(even->shade(r,h,dirToLight,lightColor));
	else
		return(odd->shade(r,h,dirToLight,lightColor));
}

void Checkerboard::print(){
	cout << "Checkerboard of size " << cellSize << "." << endl;
}

