/*
 * Grid.h
 *
 *  Created on: Sep 11, 2012
 *      Author: scottyoung
 */

#ifndef GRID_H_
#define GRID_H_

#include "Object3D.h"
#include "Group.h"
#include "MarchingInfo.h"
#include "PhongMaterial.h"
#include <vector>
#include "object3dvector.h"
#include "BoundingBox.h"
using std::vector;

class Grid: public Object3D {
public:
	Grid(Vec3f lo, Vec3f hi, int x, int y, int z, Material *mat);
	virtual ~Grid();
	void rasterizeSphere(Vec3f center, float radius);
	virtual bool intersect(const Ray &r, Hit &h, float tMin);
	virtual void setBounds();
	void print(){
		cout << "Using grid acceleration: (" << nx << ", " << ny << ", " << nz << ")" << endl;
	}
	void printContent();
	MarchingInfo initializeMarchingRay(const Ray &r, float tMin){
		return MarchingInfo(min, max, nx, ny, nz, r, tMin);
	}
	void insertObject(Object3D* obj);
	void insertGroup(Group* g);
	static Grid* make(Group *theGroup, int nx, int ny, int nz);
	void paint(){};

private:

	Vec3f min;
	Vec3f max;
	Vec3f dim;
	vector<vector<vector<Object3DVector*> > > objects;
	int nx, ny, nz;
	Material *m;
	bool RENDER_GRID;
	vector<vector<vector<bool> > > cells;
};

#endif /* GRID_H_ */
