/*
 * Object3D.h
 *
 *  Created on: Aug 10, 2012
 *      Author: scottyoung
 */

#ifndef OBJECT3D_H_
#define OBJECT3D_H_

#import "vectors.h"
#import "hit.h"
#import "ray.h"
#import "BoundingBox.h"
#include "raytracing_stats.h"

class Object3D {
public:
	Object3D();
	virtual ~Object3D();
	virtual bool intersect(const Ray &r, Hit &h, float tMin)=0;
	virtual void setBounds()=0;
	virtual void print()=0;
	virtual void paint()=0;

	BoundingBox getBoundingBox(){return bounds;}
	void setMaterial(Material *m){material = m;}

	bool isGroup;
	bool isTri;

protected:
	Material *material;
	BoundingBox bounds;
};

#endif /* OBJECT3D_H_ */
